# grdfilter

Filter a grid in the space (or time) domain

## Synopsis

gmt grdfilter ingrid -D distance_flag -F x width[/width2][+c|+h|+l|+q quantile|+u] -G outgrid [ -I increment ] [ -N i|p|r ] [ -R region ] [ -T ] [ -V[level] ] [ -f flags ] [ -r reg ] [ -x[[-]n] ] [ --PAR=value ]

Note: No space is allowed between the option flag and the associated arguments.

## Description

grdfilter will filter a grid in the time (or space) domain using one of the selected convolution or non-convolution isotropic or rectangular filters and compute distances using Cartesian or Spherical geometries. The output grid can optionally be generated as a sub-region of the input (via -R) and/or with new increment (via -I) or registration (via -T). In this way, one may have “extra space” in the input data so that the edges will not be used and the output can be within one half-width of the input edges. If the filter is low-pass, then the output may be less frequently sampled than the input. Note: For filtering in the frequency (or wavenumber) domain instead, see grdfft.

## Required Arguments

ingrid[=ID|?varname][+b band][+d divisor][+n invalid][+o offset][+s scale]

> Optionally, append =ID for reading a specific file format [Default is =nf] or ?varname for a specific netCDF variable [Default is the first 2-D grid found by GMT]. The following modifiers are supported:

> > - +b - Select a band [Default is 0].

> > - +d - Divide data values by the given divisor [Default is 1].

> > - +n - Replace data values matching invalid with NaN.

> > - +o - Offset data values by the given offset [Default is 0].

> > - +s - Scale data values by the given scale [Default is 1].

> Note: Any offset is added after any scaling.

-D flag

  Distance flag tells how grid (x, y) relates to filter width as follows:

  - flag = p: grid (px,py) with width an odd number of pixels; Cartesian distances.

  - flag = 0: grid (x, y) same units as width, Cartesian distances.

  - flag = 1: grid (x, y) in degrees, width in km, Cartesian distances.

  - flag = 2: grid (x, y) in degrees, width in km, dx scaled by cos(middle y), Cartesian distances.

  The above options are fastest because they allow weight matrix to be computed only once. The next three options are slower because they recompute weights for each latitude.

  - flag = 3: grid (x, y) in degrees, width in km, dx scaled by cosine(y), Cartesian distance calculation.

  - flag = 4: grid (x, y) in degrees, width in km, Spherical distance calculation.

  - flag = 5: grid (x, y) in Mercator -Jm1 img units, width in km, Spherical distance calculation.

-Fx width[/width2][+c|+h|+l|+q quantile|+u]

  Sets the filter type. Choose among convolution and non-convolution filters. Use any filter code x (listed below) followed by the full diameter width. This gives an isotropic filter; append /width2 for a rectangular filter (requires -Dp or -D0). By default we perform low-pass filtering; append +h to select high-pass filtering. For isotropic filters, width may be a grid for variable filter width, in which case the grid must have the same registration and dimensions as the output filtered grid. Some filters allow for optional arguments and modifiers.

  Convolution filters (and their directives) are:

  - (b) Boxcar: All weights are equal.

  - (c) Cosine Arch: Weights follow a cosine arch curve.

  - (g) Gaussian: Weights are given by the Gaussian function, where width is 6 times the conventional Gaussian sigma.

  - (f) Custom: Weights are given by the precomputed values in the filter weight grid file weight, which must have odd dimensions; also requires -D0 and output spacing must match input spacing or be integer multiples.

  - (o) Operator: Weights are given by the precomputed values in the filter weight grid file weight, which must have odd dimensions; also requires -D0 and output spacing must match input spacing or be integer multiples. Weights are assumed to sum to zero so no accumulation of weight sums and normalization will be done.

  Non-convolution filters (and their directives) are:

  - (m) Median: Returns median value. To select another quantile append +q quantile in the 0-1 range [Default is 0.5, i.e., median].

  - (p) Maximum likelihood probability (a mode estimator): Return modal value. If more than one mode is found we return their average value. Append +l or +u if you rather want to return the lowermost or uppermost of the modal values.

  - (h) Histogram mode (another mode estimator): Return the modal value as the center of the dominant peak in a histogram. Append /binwidth to specify the binning interval. Use modifier +c to center the bins on multiples of binwidth [Default has bin edges that are multiples of binwidth]. If more than one mode is found we return their average value. Append +l or +u if you rather want to return the lowermost or uppermost of the modal values.

  - (l) Lower: Return the minimum of all values.

  - (L) Lower: Return minimum of all positive values only.

  - (u) Upper: Return maximum of all values.

  - (U) Upper: Return maximum of all negative values only.

  In the case of L|U it is possible that no data passes the initial sign test; in that case the filter will return NaN.

-G outgrid[=ID][+d divisor][+n invalid][+o offset|a][+s scale|a][:driver[dataType][+c options]]

> Optionally, append =ID for writing a specific file format. The following modifiers are supported:

> > - +d - Divide data values by given divisor [Default is 1].

> > - +n - Replace data values matching invalid with a NaN.

> > - +o - Offset data values by the given offset, or append a for automatic range offset to preserve precision for integer grids [Default is 0].

> > - +s - Scale data values by the given scale, or append a for automatic scaling to preserve precision for integer grids [Default is 1].

> Note: Any offset is added before any scaling. +sa also sets +oa (unless overridden). To write specific formats via GDAL, use =gd and supply driver (and optionally dataType) and/or one or more concatenated GDAL -co options using +c. See the “Writing grids and images” cookbook section for more details.

## Optional Arguments

-I x_inc[+e|n][/y_inc[+e|n]]

  Set the grid spacing as x_inc [and optionally y_inc].

  Geographical (degrees) coordinates: Optionally, append an increment unit. Choose among:

  > - d - Indicate arc degrees

  > - m - Indicate arc minutes

  > - s - Indicate arc seconds

  > If one of e (meter), f (foot), k (km), M (mile), n (nautical mile) or u (US survey foot), the the increment will be converted to the equivalent degrees longitude at the middle latitude of the region (the conversion depends on PROJ_ELLIPSOID). If y_inc is not given or given but set to 0 it will be reset equal to x_inc; otherwise it will be converted to degrees latitude.

  All coordinates: The following modifiers are supported:

  > - +e - Slightly adjust the max x (east) or y (north) to fit exactly the given increment if needed [Default is to slightly adjust the increment to fit the given domain].

  > - +n - Define the number of nodes rather than the increment, in which case the increment is recalculated from the number of nodes, the registration (see GMT File Formats), and the domain. Note: If -R grdfile is used then the grid spacing and the registration have already been initialized; use -I and -R to override these values.

-N i|p|r

  Determine how NaN-values in the input grid affect the filtered output. Append one of three directives:

  - i: Ignore all NaNs in the calculation of filtered value [Default].

  - p: Force the filtered value to be NaN if any grid-nodes with NaN-values are found inside the filter circle.

  - r: Similar to i except if the input node was NaN then the output node will be set to NaN (only applies if both grids are co-registered).

-R

  west, east, south, and north defines the Region of the output points. [Default: Same as input.]

-T

  Toggle the node registration for the output grid so as to become the opposite of the input grid [Default gives the same registration as the input grid]. Alternatively, use -r[g|p] to set the registration explicitly.

-V[level]

  Select verbosity level [w]. (See full description) (See cookbook information).

-f[i|o]colinfo (more …)

  Specify data types of input and/or output columns.

-r[g|p] (more …)

  Set node registration [gridline].

-x[[-]n] (more …)

  Limit number of cores used in multi-threaded algorithms (OpenMP required).

-^ or just -

  Print a short message about the syntax of the command, then exit (Note: on Windows just use -).

-+ or just +

  Print an extensive usage (help) message, including the explanation of any module-specific option (but not the GMT common options), then exit.

-? or no arguments

  Print a complete usage (help) message, including the explanation of all options, then exit.

--PAR=value

  Temporarily override a GMT default setting; repeatable. See gmt.conf for parameters.

## Geographical And Time Coordinates

When the output grid type is netCDF, the coordinates will be labeled “longitude”, “latitude”, or “time” based on the attributes of the input data or grid (if any) or on the -f or -R options. For example, both -f0x -f1t and -R90w/90e/0t/3t will result in a longitude/time grid. When the x, y, or z coordinate is time, it will be stored in the grid as relative time since epoch as specified by TIME_UNIT and TIME_EPOCH in the gmt.conf file or on the command line. In addition, the unit attribute of the time variable will indicate both this unit and epoch.

## Examples

Note: Below are some examples of valid syntax for this module. The examples that use remote files (file names starting with `@`) can be cut and pasted into your terminal for testing. Other commands requiring input files are just dummy examples of the types of uses that are common but cannot be run verbatim as written.

The @earth_relief_05m is a remote file of 5 minute bathymetry and you want to find the medians of values within a 300km radius (600km full width) of the output points, which you choose to be from 150E to 250E and 10N to 40N, and you want the output values every 0.5 degree. Using spherical distance calculations, you need:

    gmt grdfilter @earth_relief_05m -Gfiltered_pacific.nc -Fm600 -D4 -R150/250/10/40 -I0.5 -V

If we instead wanted a high-pass result then one can perform the corresponding low-pass filter using a coarse grid interval as grdfilter will resample the result to the same resolution as the input grid so we can compute the residuals, e.g.,

    gmt grdfilter @earth_relief_05m -Gresidual_pacific.nc -Fm600+h -D4 -R150/250/10/40 -I0.5 -V

Here, the residual_pacific.nc grid will have the same 5 minute resolution as the original.

To filter the dataset in ripples.nc using a custom anisotropic Gaussian filter exp (-0.5*r^2) whose distances r from the center is given by (2x^2 + y^2 -2xy)/6, with major axis at an angle of 63 degrees with the horizontal, try

    gmt grdmath -R-10/10/-10/10 -I1 X 2 POW 2 MUL Y 2 POW ADD X Y MUL 2 MUL \
                SUB 6 DIV NEG 2 DIV EXP DUP SUM DIV = gfilter.nc
    gmt grdfilter ripples.nc -Ffgfilter.nc -D0 -Gsmooth.nc -V

## Limitations

1. To use the -D5 option the input Mercator grid must be created by img2mercgrd using the -C option so the origin of the y-values is the Equator (i.e., x = y = 0 correspond to lon = lat = 0).

2. If the new x_inc, y_inc set with -I are not integer multiples of the increments in the input data, filtering will be considerably slower. [Default increments: Same as input.]

## See Also

gmt, grdfft img2grd